#DAs ist ein Test
AC_DEFUN([AC_SEARCH_QWT],
[
     ac_with_Qwt=no
     ac_search_path="$QTDIR /usr/local /usr/local/qwt /opt /opt/local"

     AC_ARG_WITH(Qwt,
          AC_HELP_STRING([--with-Qwt=DIR], [root directory of Qwt installation]),
          ac_with_Qwt=$withval
          if test "x${ac_with_Qwt}" != xyes && test "x${ac_with_Qwt}" != xno; then
               ac_Qwt_include="$withval/include"
               ac_Qwt_libdir="$withval/lib"
          fi
     )

     AC_ARG_WITH([Qwt-include-dir],
          AC_HELP_STRING([--with-Qwt-include-dir=DIR], [Qwt header files are in DIR]),
          ac_with_Qwt=$withval
          if test "x${ac_with_Qwt}" != xyes && test "x${ac_with_Qwt}" != xno; then
               ac_Qwt_include="$withval"
          fi
     )

     AC_ARG_WITH([Qwt-lib-dir],
          AC_HELP_STRING([--with-Qwt-lib-dir=DIR], [The Qwt library is in DIR]),
          ac_with_Qwt=$withval
          if test "x${ac_with_Qwt}" != xyes && test "x${ac_with_Qwt}" != xno; then
               ac_Qwt_libdir="$withval"
          fi
     )

  if test "x${ac_Qwt_libdir}" == "x"; then
    for ac_qt_path_test in $ac_search_path ; do
dnl      AC_MSG_NOTICE(Check for lib path $ac_qt_path_test/lib)
      if test -r "$ac_qt_path_test/lib"; then
         ls $ac_qt_path_test/lib/libqwt*  >/dev/null 2>&1
         if test $? -eq 0; then
            if test "${build_cpu}" = "x86_64"; then
               ac_Qwt_libdir="$ac_qt_path_test/lib64"
            else
               ac_Qwt_libdir="$ac_qt_path_test/lib"
            fi
            break;
         fi
      fi
    done
  fi

   if test "x${ac_Qwt_include}" == "x"; then
    for ac_qt_path_test in $ac_search_path ; do
dnl      AC_MSG_NOTICE(Check for lib path $ac_qt_path_test/include/qwt.h)
      if test -r "$ac_qt_path_test/include/qwt.h"; then
         ac_Qwt_include="$ac_qt_path_test/include"
         break;
      fi
    done
   fi

    AC_SEARCH_QWT_LOCAL($ac_Qwt_libdir, $ac_Qwt_include)
])


# subfunction for easier reuse
AC_DEFUN([AC_SEARCH_QWT_LOCAL],
[
     OLD_LDFLAGS=$LDFLAGS
     OLD_CXXFLAGS=$CXXFLAGS

     if test "x$QT_LIBS" == "x"; then
         AC_SEARCH_QT
     fi

     if test "$1"; then
          LDFLAGS="$LDFLAGS -L$1 -L$QT_LDFLAGS -lqwt $QT_LIBS"
     fi
     if test "$2"; then
          CXXFLAGS="$CXXFLAGS -I$2 $QT_CXXFLAGS"
     fi

     AC_LANG_PUSH(C++)
     AC_MSG_CHECKING(for Qwt for Qt3 in $1)
     AC_TRY_LINK([
          #include <qwt.h>
     ],[
          ;
     ],[
     success=yes
     ],[
     success=no
     ])
     AC_MSG_RESULT($success)
     AC_LANG_POP()

     LDFLAGS=$OLD_LDFLAGS
     CXXFLAGS=$OLD_CXXFLAGS
     AM_CONDITIONAL(HAVE_QWT3, true)

     if test "x$success" != xyes; then
          AC_MSG_ERROR(Qwt not (properly) installed. Get a (free) recent version from: http://qwt.sourceforge.net/)
     else
          if test "$1"; then
               AC_SUBST(QWT_LDFLAGS, "-L$1")
               AC_SUBST(QWT_LIBS, "-lqwt")
          fi
          if test "$2"; then
               AC_SUBST(QWT_CXXFLAGS, "-I$2")
          fi
     fi

])
