/***********************************************************************************************/
/******** DANGER !! DANGER !! DANGER !! DO NOT EDIT FILE -- IT WAS GENERATED AUTOMATICALLY !!! */
/***********************************************************************************************/

/* $Id: $
 * This file is part of the SPHERE Pipeline
 * Copyright (C) 2007-2010 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * $Author: $
 * $Date: $
 * $Revision: $
 * $Name: $
 */

#include "sph_error.h"
#include "sph_cube.h"
#include "sph_pixel_description_table.h"
#include "sph_ldt.h"
#include "sph_master_frame.h"
#include "sph_double_image.h"
#include "sph_triple_image.h"
#include "sph_quad_image.h"
#include "sph_zpl_exposure.h"
#include "sph_zpl_exposure_imaging.h"
#include "sph_pixel_polyfit_table.h"
#include "sph_ird_instrument_model.h"
#include "sph_fctable.h"
#include <cpl.h>
#include <config.h>

#ifndef SPH_IFS_ASTROMETRY_H_

#define SPH_IFS_ASTROMETRY_H_
#define SPH_IFS_ASTROMETRY_VERSION SPHERE_REC_VERSIONS

/*-------------------------------------------------------------------------------
 * The Structure Definition
 * 
 * This structure contains the members of the sph_ifs_astrometry that are 
 * needed by the various methods.
 * 
 * ------------------------------------------------------------------------------
 */

typedef struct _sph_ifs_astrometry_ {
    cpl_frameset*                   inframes                              ; /* The recipe input frames */

    cpl_frameset*                   current_raw_frameset                  ; /* The frameset for one product */

    cpl_parameterlist*        inparams                              ; /* The recipe input parameters */

    cpl_parameterlist*        framecomb_parameterlist               ; /* The recipe input parameters */

    const char*                     astrometry_filename                   ; /* The parameter of ifs.astrometry.outfilename */

    int                             coll_alg                              ; /* The parameter of ifs.astrometry.coll_alg */

    int                             clean_mean_reject_high                ; /* The parameter of ifs.astrometry.clean_mean.reject_high */

    int                             clean_mean_reject_low                 ; /* The parameter of ifs.astrometry.clean_mean.reject_low */

    short                           dither                                ; /* The parameter of ifs.astrometry.dither */

    double                          threshold_sigma                       ; /* The parameter of ifs.astrometry.threshold */

    double                          companion_x                           ; /* The parameter of ird.astrometry.companion_x */

    double                          companion_y                           ; /* The parameter of ird.astrometry.companion_y */

    cpl_frameset*                   raw_science_frameset                  ; /* The IFS_ASTROMETRY_RAW frames */

    cpl_frame*                      master_dff_long1_frame                ; /* The IFS_MASTER_DFF_LONG1 frames */

    cpl_frame*                      master_dff_long2_frame                ; /* The IFS_MASTER_DFF_LONG2 frames */

    cpl_frame*                      master_dff_long3_frame                ; /* The IFS_MASTER_DFF_LONG3 frames */

    cpl_frame*                      master_dff_long4_frame                ; /* The IFS_MASTER_DFF_LONG4 frames */

    cpl_frame*                      master_dff_longbb_frame               ; /* The IFS_MASTER_DFF_LONGBB frames */

    cpl_frame*                      master_dff_short_frame                ; /* The IFS_MASTER_DFF_SHORT frames */

    cpl_frame*                      master_ifu_flat_frame                 ; /* The IFS_IFU_FLAT_FIELD frames */

    cpl_frame*                      master_dark_frame                     ; /* The IFS_MASTER_DARK frames */

    cpl_frame*                      static_badpixel_frame                 ; /* The IFS_STATIC_BADPIXELMAP frames */

    cpl_frame*                      wave_calib_frame                      ; /* The IFS_WAVECALIB frames */

} sph_ifs_astrometry;

/*-------------------------------------------------------------------------------
 * Error codes
 * 
 * Below the various error codes for this module are declared.
 * ------------------------------------------------------------------------------
 */

int sph_ifs_astrometry_create_test(cpl_plugin *);


/*-------------------------------------------------------------------------------
 * The methods
 * 
 * These are the methods for sph_ifs_astrometry.
 * 
 * ------------------------------------------------------------------------------
 */

sph_ifs_astrometry* sph_ifs_astrometry_new( cpl_frameset * frameset, 
                                              cpl_parameterlist * parlist);

sph_error_code  sph_ifs_astrometry_check_frames( sph_ifs_astrometry* self );

sph_error_code sph_ifs_astrometry_check_params( sph_ifs_astrometry* parlist );

cpl_error_code sph_ifs_astrometry_run( sph_ifs_astrometry* self );

sph_error_code sph_ifs_astrometry_delete( sph_ifs_astrometry* self );
cpl_parameterlist*  sph_ifs_astrometry_create_paramlist(void);

/* Extra function declarations that are defined in sph_ifs_astrometry.c */


/* End of extra function declarations that are defined in sph_ifs_astrometry_run.c */



#endif /*SPH_IFS_ASTROMETRY_H_*/
