/***********************************************************************************************/
/******** DANGER !! DANGER !! DANGER !! DO NOT EDIT FILE -- IT WAS GENERATED AUTOMATICALLY !!! */
/***********************************************************************************************/

/* $Id: $
 * This file is part of the SPHERE Pipeline
 * Copyright (C) 2007-2010 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * $Author: $
 * $Date: $
 * $Revision: $
 * $Name: $
 */

#include "sph_error.h"
#include "sph_cube.h"
#include "sph_pixel_description_table.h"
#include "sph_ldt.h"
#include "sph_master_frame.h"
#include "sph_double_image.h"
#include "sph_triple_image.h"
#include "sph_quad_image.h"
#include "sph_zpl_exposure.h"
#include "sph_zpl_exposure_imaging.h"
#include "sph_pixel_polyfit_table.h"
#include "sph_ird_instrument_model.h"
#include "sph_fctable.h"
#include <cpl.h>
#include <config.h>

#ifndef SPH_IFS_SIMPLE_ADI_H_

#define SPH_IFS_SIMPLE_ADI_H_
#define SPH_IFS_SIMPLE_ADI_VERSION SPHERE_REC_VERSIONS

/*-------------------------------------------------------------------------------
 * The Structure Definition
 * 
 * This structure contains the members of the sph_ifs_simple_adi that are 
 * needed by the various methods.
 * 
 * ------------------------------------------------------------------------------
 */

typedef struct _sph_ifs_simple_adi_ {
    cpl_frameset*                   inframes                              ; /* The recipe input frames */

    cpl_frameset*                   current_raw_frameset                  ; /* The frameset for one product */

    cpl_parameterlist*        inparams                              ; /* The recipe input parameters */

    cpl_parameterlist*        framecomb_parameterlist               ; /* The recipe input parameters */

    const char*                     outfilename                           ; /* The parameter of ifs.simple_adi.outfilename */

    int                             coll_alg                              ; /* The parameter of ifs.science_dr.coll_alg */

    int                             transform_method                      ; /* The parameter of ifs.simple_adi.transform_method */

    int                             filter_method                         ; /* The parameter of ifs.simple_adi.filter_method */

    double                          filter_radius                         ; /* The parameter of ifs.simple_adi.filter_rad */

    double                          fermi_temp                            ; /* The parameter of ifs.simple_adi.fermi_temp */

    double                          butter_pass                           ; /* The parameter of ifs.simple_adi.butter_pass */

    double                          butter_stop                           ; /* The parameter of ifs.simple_adi.butter_stop */

    cpl_frameset*                   science_frameset                      ; /* The IFS_SIMPLE_ADI_RAW frames */

} sph_ifs_simple_adi;

/*-------------------------------------------------------------------------------
 * Error codes
 * 
 * Below the various error codes for this module are declared.
 * ------------------------------------------------------------------------------
 */

int sph_ifs_simple_adi_create_test(cpl_plugin *);


/*-------------------------------------------------------------------------------
 * The methods
 * 
 * These are the methods for sph_ifs_simple_adi.
 * 
 * ------------------------------------------------------------------------------
 */

sph_ifs_simple_adi* sph_ifs_simple_adi_new( cpl_frameset * frameset, 
                                              cpl_parameterlist * parlist);

sph_error_code  sph_ifs_simple_adi_check_frames( sph_ifs_simple_adi* self );

sph_error_code sph_ifs_simple_adi_check_params( sph_ifs_simple_adi* parlist );

cpl_error_code sph_ifs_simple_adi_run( sph_ifs_simple_adi* self );

sph_error_code sph_ifs_simple_adi_delete( sph_ifs_simple_adi* self );
cpl_parameterlist*  sph_ifs_simple_adi_create_paramlist(void);

/* Extra function declarations that are defined in sph_ifs_simple_adi.c */


/* End of extra function declarations that are defined in sph_ifs_simple_adi_run.c */



#endif /*SPH_IFS_SIMPLE_ADI_H_*/
