/* $Id: $
 * This file is part of the SPHERE Pipeline
 * Copyright (C) 2007-2010 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * $Author: $
 * $Date: $
 * $Revision: $
 * $Name: $
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
/*-----------------------------------------------------------------------------
 Includes
 -----------------------------------------------------------------------------*/
#define _sph_ifs_simple_adi_run_C
#include <cpl.h>
#include "sph_ifs_simple_adi.h"
#include "sph_simple_adi.h"
#include "sph_error.h"
#include "sph_common_keywords.h"
#include "sph_ifs_keywords.h"
#include "sph_fits.h"
#include "sph_keyword_manager.h"
#include "sph_extract_angles.h"
#include "sph_ifs_simple_adi_common.h"
#include "sph_ifs_tags.h"
#include <strings.h>
#include <math.h>
#undef _sph_ifs_simple_adi_run_C

/*----------------------------------------------------------------------------*/
/**
 * @defgroup A SPHERE API Module
 * @par Synopsis:
 * @code
 * typedef _module_ {
 * } module
 * @endcode
 * @par Desciption:
 *
 * This module provides functionality for apertures, extending the functionality
 * as it exists for cpl_apertures.
 */
/*----------------------------------------------------------------------------*/
/**@{*/
cpl_error_code sph_ifs_simple_adi_run(sph_ifs_simple_adi* self) {
    return sph_ifs_simple_adi_common(self->inframes, self->current_raw_frameset,
            self->inparams, SPH_IFS_TAG_SIMPLE_ADI_CALIB,
            SPH_RECIPE_NAME_IFS_SCIENCE_DR, self->outfilename, self->coll_alg,
            self->transform_method, self->filter_method, self->filter_radius,
            self->fermi_temp, self->butter_pass, self->butter_stop);
}

/**@}*/
