/* $Id: $
 * This file is part of the SPHERE Pipeline
 * Copyright (C) 2007-2010 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * $Author: $
 * $Date: $
 * $Revision: $
 * $Name: $
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
/*-----------------------------------------------------------------------------
 Includes
 -----------------------------------------------------------------------------*/
#include <cpl.h>
#include "sph_error.h"
#include "sph_ifs_spec_deconv.h"
#include "sph_common_science.h"
#include "sph_common_keywords.h"
#include "sph_ifs_tags.h"
#include "sph_ifs_keywords.h"
#include "sph_fitting.h"
#include "sph_keyword_manager.h"
#include "sph_transform.h"
#include "sph_spec_deconv.h"
#include <math.h>

/*----------------------------------------------------------------------------*/
/**
 * @defgroup A SPHERE API Module
 * @par Synopsis:
 * Core of the spectra deconvolution recipe for IFS.
 *
 * @par Desciption:
 *
 * This is the core of the spectra deconvolution recipe for IFS.
 */
/*----------------------------------------------------------------------------*/
/**@{*/

cpl_error_code sph_ifs_spec_deconv_run(sph_ifs_spec_deconv* self) {
    return sph_spec_deconv(self->inframes, self->current_raw_frameset,
            self->inparams, self->framecomb_parameterlist,
            SPH_IFS_TAG_SPEC_DECONV_CALIB, SPH_RECIPE_NAME_IFS_SPEC_DECONV,
            self->outfilename, self->order, self->user_cent, self->cx, self->cy,
            self->reflambda, self->smooth_fwhm, self->science_frameset);
}

/**@}*/
