/***********************************************************************************************/
/******** DANGER !! DANGER !! DANGER !! DO NOT EDIT FILE -- IT WAS GENERATED AUTOMATICALLY !!! */
/***********************************************************************************************/

/* $Id: $
 * This file is part of the SPHERE Pipeline
 * Copyright (C) 2007-2010 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * $Author: $
 * $Date: $
 * $Revision: $
 * $Name: $
 */

#include "sph_error.h"
#include "sph_cube.h"
#include "sph_pixel_description_table.h"
#include "sph_ldt.h"
#include "sph_master_frame.h"
#include "sph_double_image.h"
#include "sph_triple_image.h"
#include "sph_quad_image.h"
#include "sph_zpl_exposure.h"
#include "sph_zpl_exposure_imaging.h"
#include "sph_pixel_polyfit_table.h"
#include "sph_ird_instrument_model.h"
#include "sph_fctable.h"
#include <cpl.h>
#include <config.h>

#ifndef SPH_IRD_SPECTRA_RESOLUTION_H_

#define SPH_IRD_SPECTRA_RESOLUTION_H_
#define SPH_IRD_SPECTRA_RESOLUTION_VERSION SPHERE_REC_VERSIONS

/*-------------------------------------------------------------------------------
 * The Structure Definition
 * 
 * This structure contains the members of the sph_ird_spectra_resolution that are 
 * needed by the various methods.
 * 
 * ------------------------------------------------------------------------------
 */

typedef struct _sph_ird_spectra_resolution_ {
    cpl_frameset*                   inframes                              ; /* The recipe input frames */

    cpl_frameset*                   current_raw_frameset                  ; /* The frameset for one product */

    cpl_parameterlist*        inparams                              ; /* The recipe input parameters */

    cpl_parameterlist*        framecomb_parameterlist               ; /* The recipe input parameters */

    const char*                     outfilename                           ; /* The parameter of ird.spectra_resolution.outfilename */

    int                             coll_alg                              ; /* The parameter of ird.spectra_resolution.coll_alg */

    int                             clean_mean_reject_high                ; /* The parameter of ird.spectra_resolution.clean_mean.reject_high */

    int                             clean_mean_reject_low                 ; /* The parameter of ird.spectra_resolution.clean_mean.reject_low */

    double                          threshold_sigma                       ; /* The parameter of ird.spectra_resolution.threshold */

    double                          wavelength_line1                      ; /* The parameter of ird.spectra_resolution.wavelength_line1 */

    double                          wavelength_line2                      ; /* The parameter of ird.spectra_resolution.wavelength_line2 */

    int                             miny                                  ; /* The parameter of ird.spectra_resolution.miny */

    double                          c1                                    ; /* The parameter of ird.spectra_resolution.c1 */

    double                          c2                                    ; /* The parameter of ird.spectra_resolution.c2 */

    double                          c3                                    ; /* The parameter of ird.spectra_resolution.c3 */

    double                          c4                                    ; /* The parameter of ird.spectra_resolution.c4 */

    cpl_frameset*                   rawframes                             ; /* The IRD_SPECTRA_RESOLUTION_RAW frames */

    cpl_frame*                      master_flat_frame                     ; /* The IRD_FLAT_FIELD frames */

    cpl_frame*                      master_dark_frame                     ; /* The IRD_MASTER_DARK frames */

    cpl_frame*                      wave_calib_frame                      ; /* The IRD_WAVECALIB frames */

    cpl_frame*                      mask_frame                            ; /* The IRD_STATIC_BADPIXELMAP frames */

    double                          y0                                    ; /* The lineposition data field */

} sph_ird_spectra_resolution;

/*-------------------------------------------------------------------------------
 * Error codes
 * 
 * Below the various error codes for this module are declared.
 * ------------------------------------------------------------------------------
 */

int sph_ird_spectra_resolution_create_test(cpl_plugin *);


/*-------------------------------------------------------------------------------
 * The methods
 * 
 * These are the methods for sph_ird_spectra_resolution.
 * 
 * ------------------------------------------------------------------------------
 */

sph_ird_spectra_resolution* sph_ird_spectra_resolution_new( cpl_frameset * frameset, 
                                              cpl_parameterlist * parlist);

sph_error_code  sph_ird_spectra_resolution_check_frames( sph_ird_spectra_resolution* self );

sph_error_code sph_ird_spectra_resolution_check_params( sph_ird_spectra_resolution* parlist );

cpl_error_code sph_ird_spectra_resolution_run( sph_ird_spectra_resolution* self );

sph_error_code sph_ird_spectra_resolution_delete( sph_ird_spectra_resolution* self );
cpl_parameterlist*  sph_ird_spectra_resolution_create_paramlist(void);

/* Extra function declarations that are defined in sph_ird_spectra_resolution.c */


/* End of extra function declarations that are defined in sph_ird_spectra_resolution_run.c */



#endif /*SPH_IRD_SPECTRA_RESOLUTION_H_*/
