/* $Id: $
 * This file is part of the SPHERE Pipeline
 * Copyright (C) 2007-2010 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * $Author: $
 * $Date: $
 * $Revision: $
 * $Name: $
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

/*-----------------------------------------------------------------------------
 Includes
 -----------------------------------------------------------------------------*/
#include <cpl.h>
#include "sph_error.h"
#include "sph_framecombination.h"
#ifndef SHARED_IRDIFS_H_
#define SHARED_IRDIFS_H_

sph_master_frame*
sph_irdifs_master_dark_create(cpl_frameset* rawframes,
        sph_collapse_algorithm coll_alg, cpl_parameterlist* framecomb,
        double sigma_clip, double smoothing, double min_accept,
        double max_accept, int nskip, cpl_image** static_bpix);

sph_pixel_polyfit_table*
sph_irdifs_detector_persistence_create_fit(sph_master_frame* dark, int fitorder,
        cpl_frameset* rawframes);
cpl_error_code
sph_irdifs_detector_persistence_run(cpl_frame* static_badpixel_frame,
        cpl_frame* master_dark_frame, cpl_frameset* satframes,
        cpl_frameset* unsatframes, sph_collapse_algorithm coll_alg,
        cpl_parameterlist* framecomb_parameterlist, cpl_frameset* rawframes,
        cpl_frameset* inframes, cpl_parameterlist * inparams,
        double threshold_dark, double threshold_ill, double fitorder,
        const char* outfilename, const char* tag, const char* recipe,
        const char* pipeline);
cpl_vector*
sph_irdifs_detector_persistence_get_timing(cpl_frameset** prawframes,
        double atime0);
#endif /* SHARED_IRDIFS_H_ */
