/* $Id: $
 * This file is part of the SPHERE Pipeline
 * Copyright (C) 2007-2010 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * $Author: $
 * $Date: $
 * $Revision: $
 * $Name: $
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

/*-----------------------------------------------------------------------------
 Includes
 -----------------------------------------------------------------------------*/
#include <cpl.h>
#include "sph_error.h"
#include "sph_interpolation.h"
#ifndef cutest_sph_interpolation_H_
#define cutest_sph_interpolation_H_

static
int
cutest_sph_interpolation_init_testsuite(void);

static
int
cutest_sph_interpolation_clean_testsuite(void);

static
void
cutest_sph_interpolation_find_closest_points(void);

static
void cutest_sph_interpolation_find_closest_points_too_few(void);

static
void cutest_sph_interpolation_prepare_index_assocs(void);

static
void cutest_sph_interpolation_find_closest_points_many_reps(void);

static
void cutest_sph_interpolation_interpolate(void);

static cpl_vector*
__cutest_sph_interpolation_find_closest_brute_force(double xpos, double ypos,
        cpl_array* xpositions, cpl_array* ypositions, int n);
static sph_interpolation*
__cutest_sph_interpolation_arrays_fixture(int np, int nx, int ny);
#endif /* cutest_sph_interpolation_H_ */
