/* $Id: $
 * This file is part of the SPHERE Pipeline
 * Copyright (C) 2007-2010 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * $Author: $
 * $Date: $
 * $Revision: $
 * $Name: $
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

/*-----------------------------------------------------------------------------
 Includes
 -----------------------------------------------------------------------------*/
#include <cpl.h>
#include "sph_error.h"
#ifndef CUTEST_SPH_LDT_H_
#define CUTEST_SPH_LDT_H_

int cutest_init_ldt_testsuite();

int cutest_clean_ldt_testsuite();

void cutest_ldt_new();

void cutest_ldt_divide();

void cutest_ldt_new_rotate();

void cutest_ldt_save();

void cutest_ldt_save_big_cube();

void cutest_ldt_save_big();

void cutest_ldt_new_load();

void cutest_ldt_create_image();

void cutest_ldt_new_from_pdt_image();

void cutest_ldt_new_from_pdt_master_frame();

void cutest_ldt_create_detframe();

void cutest_ldt_delete();
#endif /* SPH_CUTEST_LDT_H_ */
