/* $Id: $
 * This file is part of the SPHERE Pipeline
 * Copyright (C) 2007-2010 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * $Author: $
 * $Date: $
 * $Revision: $
 * $Name: $
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

/*-----------------------------------------------------------------------------
 Includes
 -----------------------------------------------------------------------------*/
#include <cpl.h>
#include "sph_error.h"
#ifndef CUTEST_SPH_POLYNOMIAL_DISTORTION_MODEL_H_
#define CUTEST_SPH_POLYNOMIAL_DISTORTION_MODEL_H_

static sph_polynomial_distortion_model*
cutest_sph_polynomial_distortion_model_fixture();

static sph_polynomial_distortion_model*
cutest_sph_polynomial_distortion_model_fixture2();

cpl_image*
cutest_sph_polynomial_distortion_model_fixture_tough(int nx, int ny,
        int points_per_side, double fwhm,
        sph_polynomial_distortion_model** distmodel_out,
        sph_point_pattern* pp_ideal);

static sph_polynomial_distortion_model*
cutest_sph_polynomial_distortion_model_fixture2inv();
static
void
cutest_sph_polyonmial_distortion_model_from_grid();

static
void
cutest_sph_polyonmial_distortion_model_from_grid_no_dist();

static
int
cutest_sph_polyonmial_distortion_model_saveit();

static
int cutest_init_testsuite();

static
int cutest_clean_testsuite();

static
void cutest_sph_polyonmial_distortion_model_test_fit_distortion_map_temp();

static
void cutest_sph_polyonmial_distortion_model_test_save();

static
void cutest_sph_polyonmial_distortion_model_test_load();

static
void cutest_sph_polyonmial_distortion_model_apply_timing();

static
void cutest_sph_polyonmial_distortion_model_apply_poly();

static
void cutest_sph_polyonmial_distortion_model_apply();

static
void cutest_sph_polyonmial_distortion_model_apply_highorder();
static
void cutest_sph_polyonmial_distortion_model_check_cpl_bug();
static
void cutest_sph_polyonmial_distortion_model_check_cpl_leakage();

#endif /* CUTEST_SPH_POLYNOMIAL_DISTORTION_MODEL_H_ */
